extern int     AnalyzeDays.Count          =  12;
extern int     AnalyzeDays.OffsetHrs      =  16;
void OptMapParameters(){
   OptMapToInt   ("TZselect.Brk0_UTC1_NY2      ", TZselect.Brk0_UTC1_NY2      );
   OptMapToDouble("Trade.Hr.Start              ", Trade.Hr.Start              );
   OptMapToDouble("Trade.Hr.End                ", Trade.Hr.End                );
   :
//+------------------------------------------------------------------+
//| Multi-Optimization functions                                     |
//+------------------------------------------------------------------+
//{WantedMode = Opt.Mode - 1 and WantedLine = Opt.Counter. Read the .opt file
// for the line WantedMode, WantedLine. That contains all the parameters that
// need to be modified for this run. Extract them and continue. On the
// OptComplete call, if the run was profitable, then I need to append to the
// .opt file all the parameters plus Opt.Mode and Opt.counter for the next
//}group.
double   opt.initAB, opt.profit.ave, opt.profit.tot;  // Export to OptComplete
int      opt.pass;                                    // Export to OptComplete
void     OptInitialization(){
   if(Opt.Mode > 0) if(Opt.Counter < 1){  AlertMe(
         "OptParameters: Pass=" + Opt.Counter + "/" + Opt.Mode + " (invalid)" );
      Opt.Mode = -1;                                                 return;  }
   opt.initAB           = AccountBalance();
   opt.profit.ave       = 0;
   opt.profit.tot       = 0;
   opt.pass             = 1;  // Assume .opt is EMPTY or NSF.
      string   nameOPT  = WindowExpertName() + ".OPT";
   int      handleOPT   = FileOpen(nameOPT, FILE_CSV|FILE_READ, '~');
   if(handleOPT < 1){
      if(Opt.Mode > 0){ int GLE = GetLastError();
         AlertMe("OptInitialization: FileOpen(", nameOPT,") Failed: ", GLE);
         Opt.Mode = -1;                                              return;  }
      // First pass of initial optimization. Externals are set in tester.

      Log( "Pass=    1/0 inputs: ", OptGetParameters() );            return;  }
   while(Opt.Mode == 0){            // Find the highest profitable pass so far.
      string   line = FileReadString(handleOPT);   if(line == ""){   // EOF?
         Log("Pass=" + RJust(opt.pass, 5, " ") +"/0 inputs: ",
            OptGetParameters() );   FileClose(handleOPT);            return;
      }
            int      passBeg  = StringFindPast(line, "Opt.Pass="),
                     passEnd  = StringFind(line, "/", passBeg);
         string   pass        = StringSubstr(line, passBeg, passEnd-passBeg);
      int      nPass          = StrToInteger(pass);
      if(nPass >= opt.pass)   opt.pass = nPass + 1;            // Last plus one.
   }  // mode=0
   #define TAB "\t"                                            // Mode > 0
   opt.pass = Opt.Counter; // Update will be same as Counter, new mode.
   string want = "Opt.Pass=" + RJust(Opt.Counter,5," ")
               + "/" + (Opt.Mode-1) + TAB;
   while(true){                                 // Find my previous parameters.
      line = FileReadString(handleOPT);   if(line == ""){
         GLE = GetLastError();   FileClose(handleOPT);   AlertMe(
         "OptInitialization: Error ", GLE, " reading OPT file for: '",want,"'");
         Opt.Mode = -1;                                              return;  }
      passBeg  = StringFind(line, want);  if(passBeg >= 0)  break;
   }                                            // Find my previous parameters.
   FileClose(handleOPT);   // Found
   //Opt.Profit=x/x<tab>Opt.Pass=y/y<tab>PARAM1=Val1<tab>...
         int      aveStart    = StringFindPast(line, "Profit="),
                  aveEnd      = StringFind(line, "/", aveStart),
                  totStart    = aveEnd + 1,
                  totEnd      = StringFind(line, TAB, totStart);
      string   ave            = StringSubstr(line, aveStart, aveEnd-aveStart),
               tot            = StringSubstr(line, totStart, totEnd-totStart);
   opt.profit.ave = StrToDouble(ave);
   opt.profit.tot = StrToDouble(tot);

   int      nameBeg     = StringFindPast(line, TAB, passBeg);
   while(true){
      int      nameEnd  = StringFind(line, "=", nameBeg);
      if(nameEnd < 0)  break;
         int      valueBeg  = nameEnd + 1,                  // Skip equal sign.
                  valueEnd    = StringFind(line, TAB, valueBeg);
      string   name  = StringSubstr(line,  nameBeg,  nameEnd  - nameBeg),
               value = StringSubstr(line, valueBeg, valueEnd - valueBeg);
      OptSetParameter(name, value);
      nameBeg  = valueEnd + 1;                              // Skip tab.
   }
   Log( "Pass=" + RJust(opt.pass, 5, " ") +"/"+ Opt.Mode
      + " inputs: ", OptGetParameters() );
   return;
}  // OptInitialization
int StringFindPast(string text, string what, int start=0){
   int      where = StringFind(text, what, start);
   if (where >= 0)   where += StringLen(what);
   return(where);
}
string   opt.parameters,                           // Export to OptComplete and
         opt.var.name, opt.var.value;              // Export to OptMapToXXX
string   OptGetParameters(){                       // Sets opt.parameters
   opt.parameters = "";                            // initialize for append
   opt.var.name   = ""; OptMapParameters();  return(opt.parameters);
}
void     OptSetParameter(string name, string value){  // Sets &name = value;
   opt.var.name = name; opt.var.value = value;  OptMapParameters();
}
void     OptMapToInt(string text, int& var){
// string   opt.var.name, opt.var.value;     // \ Import from OptGetParameters
//          opt.parameters                   // / or from OptSetParameter
   text = StringTrimRight(text);             // OptMapParameters formatting.
   if      (opt.var.name == "")              // Output only
      opt.parameters = opt.parameters + text + "=" + var + TAB;
   else  if(opt.var.name == text)            // Found name to variable. Set it.
      var            = StrToInteger(opt.var.value);
// else  not a match.
}
void     OptMapToDouble(string text, double& var){
   text = StringTrimRight(text);
   if      (opt.var.name == "")                       // DtS: 1.60000000 -> 1.6.
      opt.parameters = opt.parameters + text + "=" + DoubleToString(var) + TAB;
   else  if(opt.var.name == text)
      var            = StrToDouble(opt.var.value);
}
void     OptComplete(){
   if(!IsTesting())  return;     if(IsVisualMode())   return;
   double   profit = AccountBalance() - opt.initAB;
   if      (Opt.Mode == 0){   opt.profit.ave = profit;
                              opt.profit.tot = profit;                        }
   else  if(profit > 0.){
      //{http://en.wikipedia.org/wiki/Geometric_mean geometric mean is more
      // appropriate than the arithmetic mean for describing proportional grow-
      // th, both exponential growth (constant proportional growth) and varying
      // growth; in business the geometric mean of growth rates is known as the
      // compound annual growth rate (CAGR). The geometric mean of growth over
      // periods yields the equivalent constant growth rate that would yield the
      //}same final amount. gm = (X1 * X2 * X3)^(1/3)
      double   product     = MathPow(opt.profit.ave, Opt.Mode) * profit;
      opt.profit.ave = MathPow(product, 1./(Opt.Mode + 1));
      opt.profit.tot += profit;                                               }
   Log( "Pass=" + RJust(opt.pass, 5, " ") +"/"+ Opt.Mode
               + " profit="   + CurrencyToStr(profit)
               + " ave= "     + CurrencyToStr(opt.profit.ave)
               + " tot= "     + CurrencyToStr(opt.profit.tot) );
   if(Opt.Mode < 0 || profit <= 0)  return;        // No entry for loosers.
   int         APPEND   = FILE_CSV|FILE_WRITE|FILE_READ;
   string      nameOPT  = WindowExpertName() + ".OPT";
   int      handleOPT   = FileOpen(nameOPT, APPEND, '~');   if(handleOPT < 1){
      AlertMe( "OptComplete: FileOpen(", nameOPT,") Failed: ", GetLastError() );
                                                                     return;  }
   FileSeek(handleOPT, 0, SEEK_END);
   FileWrite( handleOPT,
      "Opt.Profit="  + RJust(DoubleToStr(opt.profit.ave,2), 9, " ")
      + "/"          + RJust(DoubleToStr(opt.profit.tot,2), 9, " ")  + TAB
      + "Opt.Pass="  + RJust(opt.pass, 5, " ") + "/" + Opt.Mode      + TAB
      + opt.parameters  // In case externals were modified, use initial params.
   );
   FileClose(handleOPT);
}  // OptComplete
//{Log
// send information to OutputDebugString() to be viewed and logged by
// SysInternal's DebugView (free download from Microsoft) This is ideal for
// debugging as an alternative to Print(). The function will take up to 10
// strings (or numeric) arguments to be concatenated into one debug message.
// http://technet.microsoft.com/en-us/sysinternals/bb896647.aspx
//}
#import "kernel32.dll"
   void     OutputDebugStringA(string msg);
#import
// int init(){                                           #define CS_LIVE      0
//                                                       #define CS_VISUAL    1
// if      (!IsTesting())     status.chart   = CS_LIVE;  #define CS_OPTIMIZER 2
// else  if(IsVisualMode())   status.chart   = CS_VISUAL;
// else{                      status.chart   = CS_OPTIMIZER;
//                            Show.Comments  = false;
//                            Show.Objects   = false;                         }
// ...}
void     Log(string s1, string s2="", string s3="", string s4="", string s5="",
         string s6="", string s7="", string s8="", string s9="", string s10=""){
   if( IsDllsAllowed() ){
      if(status.chart == CS_LIVE)   string out = "";
      else  // Visual or Optimizer
         out = TimeToStr(timeCur.srv, TIME_DATE|TIME_MINUTES|TIME_SECONDS) +" ";
      out   = out + WindowExpertName() + ": "
                  + s1 + s2 + s3 + s4 + s5 + s6 + s7 + s8 + s9 + s10;
      OutputDebugStringA(out);
}  }
void  AlertMe(string s1, string s2="", string s3="", string s4="", string s5="",
         string s6="", string s7="", string s8="", string s9="", string s10=""){
   Alert(s1, s2, s3, s4, s5, s6, s7, s8, s9, s10);
     Log(s1, s2, s3, s4, s5, s6, s7, s8, s9, s10);
}
